#!/usr/bin/env python3
# -*- encoding: utf-8; py-indent-offset: 4 -*-
# +------------------------------------------------------------+
# |                                                            |
# |             | |             | |            | |             |
# |          ___| |__   ___  ___| | ___ __ ___ | | __          |
# |         / __| '_ \ / _ \/ __| |/ / '_ ` _ \| |/ /          |
# |        | (__| | | |  __/ (__|   <| | | | | |   <           |
# |         \___|_| |_|\___|\___|_|\_\_| |_| |_|_|\_\          |
# |                                   custom code by SVA       |
# |                                                            |
# +------------------------------------------------------------+
#
# Copyright (C) 2021  Jeronimo Wiederhold <jeronimo.wiederhold@sva.de>
#                     for SVA System Vertrieb Alexander GmbH

# Example output
"""
<name>|<state>
<<<hpe_oneview_appliance_state:sep(124)>>>
OK
"""

from .agent_based_api.v1 import *

info_list = ["name", "state"]
state_map = {
    0: State.OK,
    1: State.WARN,
    2: State.CRIT,
    3: State.UNKNOWN
}

def discovery_hpe_oneview_appliance_state(section):
    if section is not []:
        yield Service()


def check_hpe_oneview_appliance_state(params, section):
    map_state = params["map_state"]
    state = section[0][0]

    s=state_map[map_state[state]]
            
    yield Result(state=s, summary="State: {}".format(state))


register.check_plugin(
    name="hpe_oneview_appliance_state",
    service_name="Appliance State",
    check_ruleset_name="hpe_oneview_appliance_state",
    check_default_parameters={
        "map_state": {
                "OK": 0,
                "CONFIGURATION_ERROR": 2,
                "ERROR": 2,
                "FACTORY_RESET": 1,
                "FAILOVER": 1,
                "INCOMPATIBLE_MODEL_ERROR": 2,
                "NETWORK_ERROR": 2,
                "RESTORE": 1,
                "RESTORE_NO_RESET_ERROR": 2,
                "STARTING": 0,
                "STOPPED": 2,
                "UPGRADE": 0,
            },
        },
    discovery_function=discovery_hpe_oneview_appliance_state,
    check_function=check_hpe_oneview_appliance_state,
)